/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Tue Jan 31 13:35:17 2006
 */
#include "halo2.h"

void ShiftLightMapRaw(MAP_STRUCT Map, int lightmap, int offset){
	uint32 RawCount,RawReflexOffset,ReflexivePacketOffset, i, Offset;
	ReflexivePacketOffset	=	GetReflexiveAddressTag(Map,lightmap,128);
	RawReflexOffset			=	GetReflexiveAddress(Map,ReflexivePacketOffset+64);
	RawCount				=	GetReflexiveChunkCount(Map,ReflexivePacketOffset+64);
	for(i=0;i<RawCount;i++){
		fseek(Map.Stream,
		RawReflexOffset+(i*52)+12,0);
		fread(&Offset,1,sizeof(uint32),Map.Stream);
		Offset+= (isNotExtern(Offset)==0)?offset:0;
		fseek(Map.Stream,
		RawReflexOffset+(i*52)+12,0);
		fwrite(&Offset,1,sizeof(uint32),Map.Stream);
	}
}

LightMapColour *GetLightMapColourStruct(MAP_STRUCT Map, int *count,int lightmap){
	uint32 ColourCount,CoulourReflexOffset,ReflexivePacketOffset;
	LightMapColour *Ret;
	ReflexivePacketOffset	=	GetReflexiveAddressTag(Map,lightmap,128);
	CoulourReflexOffset		=	GetReflexiveAddress(Map,ReflexivePacketOffset+8);
	ColourCount				=	GetReflexiveChunkCount(Map,ReflexivePacketOffset+8);
	Ret						=	calloc(ColourCount*1024,sizeof(LightMapColour));
	
	fseek(Map.Stream,
	CoulourReflexOffset,0);
	fread(Ret,ColourCount*1024,sizeof(LightMapColour),Map.Stream);
	count[0]	=	ColourCount;
	return			Ret;
}

void WriteLightMapColourStruct(MAP_STRUCT Map, int count, int lightmap,LightMapColour *colours){
	uint32 ColourCount,CoulourReflexOffset,ReflexivePacketOffset;
	ReflexivePacketOffset	=	GetReflexiveAddressTag(Map,lightmap,128);
	CoulourReflexOffset		=	GetReflexiveAddress(Map,ReflexivePacketOffset+8);
	ColourCount				=	(count< GetReflexiveChunkCount(Map,ReflexivePacketOffset+8))? count:GetReflexiveChunkCount(Map,ReflexivePacketOffset+8);

	fseek(Map.Stream,
	CoulourReflexOffset,0);
	fwrite(colours,ColourCount*1024,sizeof(LightMapColour),Map.Stream);
}
