#include <stdio.h>
#include <stdlib.h>
#include "halo2.h"
typedef struct {
        uint32 offset;
        uint32 size;
        uint8 *data;
}MODEL;
int InsertNull(FILE *fp, uint32 offset, int size){
	char *buffer;
	uint32 filesize;
	fseek(fp,0,SEEK_END);
	filesize	=	ftell(fp);
	buffer		=	malloc(filesize+size);
	if(buffer == NULL)
		return -1;
	memset(buffer,0,filesize+size);
	fseek(fp,0,0);
	fread(buffer,1,offset,fp);			//FLAGGED! offset-1
 	fread(buffer+(size+offset),1,filesize-offset,fp);
	fseek(fp,0,0);
	fwrite(buffer,1,filesize+size,fp);
	free(buffer);
	return 0;
}


int main(int argc, char *argv[])
{
    int count;
	uint32 refOffset,refCount,RawOffset,i,j,size;
    uint32 offset,BSP,SourceBSP,SourceBSPTag,baseMagic,base;
	Reflexive Reflex[1],Reflex2[1];
    MAP_STRUCT Map,Source;
    MODEL *Imports;
    FILE *out;
    char *buff, *string;
    uint16 space=0x0A0D;
    if(argc-3 != 1){
            printf("Improper Usage. %d args used. Use:\nISBSPR [Destination] [Source] [BSP #]\n",argc-1);
            system("pause");
            exit(0);
    }
    Source = OpenMap(argv[2]);
    if( Source.Stream==NULL){
            printf("Woah, Map I/O Error.\n");
            system("pause");
            exit(0);
    }
brunch:
    //printf("Which BSP do you want to use?(0-%d)\nBSP:",Source.bspCount-1);
    sscanf(argv[3],"%d",&SourceBSP);
    if(SourceBSP<0 || SourceBSP>Source.bspCount-1){
         printf("Chose a proper number!\n");
         exit(0);
         goto brunch;
    }
    for(i=1;i<Source.bspCount;i++){
     //  Source.BSPs[i].Offset=133490176;
    }
  //  printf("What is the base of the injection?(Hex)\nAddress:0x");
   // scanf("%x",&base);
    printf("BSP: %d\nBSP Offset: 0x%x\nBSP Magic: 0x%x\n",SourceBSP,Source.BSPs[SourceBSP].Offset,Source.BSPs[SourceBSP].Magic);
    printf("Ok beginning!\nCounting raw refrences & allocating memory...");
    SourceBSPTag=Source.BSPs[SourceBSP].Tag;
    
	refCount	=	GetReflexiveChunkCountTag(Source,SourceBSPTag,172);
	refCount	+=	GetReflexiveChunkCountTag(Source,SourceBSPTag,328);
	//MODE 3
	refOffset	=	GetReflexiveAddressTag(Source,SourceBSPTag,580);
	fseek(Source.Stream,refOffset+16,0);
	fread(Reflex,1,sizeof(Reflexive),Source.Stream);
	refCount	+=	Reflex[0].ChunkCount;
	//MODE 4
	fseek(Source.Stream,Source.BSPs[SourceBSP].Offset+8,0);
	fread(&refOffset,1,4,Source.Stream);
	refOffset	-=	Source.BSPs[SourceBSP].Magic;	
	if (refOffset+Source.BSPs[SourceBSP].Magic != 0 ) {
                                    
         fseek(Source.Stream,refOffset+128,0);
	     fread(Reflex2,1,sizeof(Reflexive),Source.Stream);
	     refOffset	=	Reflex2[0].Offset-Source.BSPs[SourceBSP].Magic;
	
    	 fseek(Source.Stream,refOffset+64,0);
	     fread(Reflex,1,sizeof(Reflexive),Source.Stream);
	     refCount	+=	Reflex[0].ChunkCount;
	}else{     
		refCount	+=	0;
	} 
    Imports     =  calloc(refCount,sizeof(MODEL));
    printf("Done! With a count of %d refs!\nCollecting raw pointer info & raw data...",refCount);
///////////////////////////
    j           =   0;
	refOffset	=	GetReflexiveAddressTag(Source,SourceBSPTag,172);
	refCount	=	GetReflexiveChunkCountTag(Source,SourceBSPTag,172);
	for(i=0;i<refCount;i++){
		fseek(Source.Stream,refOffset+(i*176)+40,0);
		fread(&Imports[j].offset,1,sizeof(uint32),Source.Stream);
		fread(&Imports[j].size,1,sizeof(uint32),Source.Stream);
		Imports[j].data = malloc(Imports[j].size);
		fseek(Source.Stream,Imports[j].offset,0);
		fread(Imports[j].data,1,Imports[j].size,Source.Stream);
		j++;
	}
	refOffset	=	GetReflexiveAddressTag(Source,SourceBSPTag,328);
	refCount	=	GetReflexiveChunkCountTag(Source,SourceBSPTag,328);
	for(i=0;i<refCount;i++){
		fseek(Source.Stream,refOffset+(i*200)+40,0);
		fread(&Imports[j].offset,1,sizeof(uint32),Source.Stream);
		fread(&Imports[j].size,1,sizeof(uint32),Source.Stream);
		Imports[j].data = malloc(Imports[j].size);
		fseek(Source.Stream,Imports[j].offset,0);
		fread(Imports[j].data,1,Imports[j].size,Source.Stream);
		j++;
	}
	//MODE 3
	refOffset	=	GetReflexiveAddressTag(Source,SourceBSPTag,580);
	fseek(Source.Stream,refOffset+16,0);
	fread(Reflex,1,sizeof(Reflexive),Source.Stream);
	refOffset	=	Reflex[0].Offset-Source.BSPs[SourceBSP].Magic;
	refCount	=	Reflex[0].ChunkCount;
	if(refOffset==(-1) || refCount==(-1)){
    	refCount	=	0;
    }
	for(i=0;i<refCount;i++){
		fseek(Source.Stream,refOffset+(i*44),0);
		fread(&Imports[j].offset,1,sizeof(uint32),Source.Stream);
		fread(&Imports[j].size,1,sizeof(uint32),Source.Stream);
		Imports[j].data = malloc(Imports[j].size);
		fseek(Source.Stream,Imports[j].offset,0);
		fread(Imports[j].data,1,Imports[j].size,Source.Stream);
		j++;
	}
	//MODE 4
	fseek(Source.Stream,Source.BSPs[SourceBSP].Offset+8,0);
	fread(&refOffset,1,4,Source.Stream);
	refOffset	-=	Source.BSPs[SourceBSP].Magic;	
	if (refOffset+Source.BSPs[SourceBSP].Magic != 0 ) {
                                    
         fseek(Source.Stream,refOffset+128,0);
	     fread(Reflex2,1,sizeof(Reflexive),Source.Stream);
	     refOffset	=	Reflex2[0].Offset-Source.BSPs[SourceBSP].Magic;
	     refCount	=	Reflex2[0].ChunkCount;
	
    	 fseek(Source.Stream,refOffset+64,0);
	     fread(Reflex,1,sizeof(Reflexive),Source.Stream);
	     refOffset	=	Reflex[0].Offset-Source.BSPs[SourceBSP].Magic;
	     refCount	=	Reflex[0].ChunkCount;
	}else{     
		refCount	=	0;
	}
	for(i=0;i<refCount;i++){
		fseek(Source.Stream,refOffset+(i*56)+12,0);
		fread(&Imports[j].offset,1,sizeof(uint32),Source.Stream);
		fread(&Imports[j].size,1,sizeof(uint32),Source.Stream);
		Imports[j].data = malloc(Imports[j].size);
		fseek(Source.Stream,Imports[j].offset,0);
		fread(Imports[j].data,1,Imports[j].size,Source.Stream);
		j++;
	}
    printf("Done!\nCalculating Base factor..");
    baseMagic= Imports[0].offset;
    size = Imports[0].offset +Imports[0].size;
	for(i=0;i<j;i++){
              /* if(Imports[i].offset +Imports[i].size>size){
                       size = Imports[i].offset + Imports[i].size;
                       if(size % 512 != 0){
                               size/=512;
                               size++;
                               size*=512;
                       }
               }*/
               Imports[i].offset=0;
    }
	for(i=1;i<j;i++){
                  Imports[i].offset = Imports[i-1].offset + Imports[i-1].size;
                  if(Imports[i].offset % 512 != 0){
                         Imports[i].offset/=512;
                         Imports[i].offset++;
                         Imports[i].offset*=512;
                  } 
                  size= Imports[i].offset +  Imports[i].size;
                  if(size % 512 != 0){
                         size/=512;
                         size++;
                         size*=512;
                  } 
                        
    }
  //  size=0;
    
         
/////////////////////////// 
    CloseMap(Source);
    Map    = OpenMap(argv[1]);
    printf("Done!\nAdding Space...");
    printf("0x%x\n",size);
    InsertNull(Map.Stream, Map.Header->indexOffset,size);
    base=Map.Header->indexOffset;
    Map.Header->indexOffset+=size;
    fseek(Map.Stream,0,0);
    fwrite(Map.Header,1,2048,Map.Stream);
    
	for(i=0;i<j;i++){
             // Imports[i].offset-=baseMagic;
              Imports[i].offset+=base;
   }
    printf("Done!\nFixing offsets...");
    j=0;   
    BSP=Map.BSPs[0].Tag;
    printf("Magic: 0x%x\n",Map.BSPs[0].Magic+Map.BSPs[0].Offset);
	refOffset	=	GetReflexiveAddressTag(Map,Map.BSPs[0].Tag,172);
	refCount	=	GetReflexiveChunkCountTag(Map,Map.BSPs[0].Tag,172);
	printf("First reflexive points to 0x%x\n with a count of %d\n",refOffset,refCount);
	for(i=0;i<refCount;i++){
		RawOffset =  Imports[j].offset;
		fseek(Map.Stream,Imports[j].offset,0);
		fwrite(Imports[j].data,1,Imports[j].size,Map.Stream);
		fseek(Map.Stream,refOffset+(i*176)+40,0);
		fwrite(&RawOffset,1,sizeof(uint32),Map.Stream);
		j++;
	}
	refOffset	=	GetReflexiveAddressTag(Map,Map.BSPs[0].Tag,328);
	refCount	=	GetReflexiveChunkCountTag(Map,Map.BSPs[0].Tag,328);
	printf("2nd reflexive points to 0x%x\n with a count of %d\n",refOffset,refCount);
	for(i=0;i<refCount;i++){
		RawOffset =  Imports[j].offset;
		fseek(Map.Stream,Imports[j].offset,0);
		fwrite(Imports[j].data,1,Imports[j].size,Map.Stream);
		fseek(Map.Stream,refOffset+(i*200)+40,0);
		fwrite(&RawOffset,1,sizeof(uint32),Map.Stream);
		j++;
	}
	//MODE 3
	refOffset	=	GetReflexiveAddressTag(Map,Map.BSPs[0].Tag,580);
	
	fseek(Map.Stream,refOffset+16,0);
	fread(Reflex,1,sizeof(Reflexive),Map.Stream);
	refOffset	=	Reflex[0].Offset-Map.BSPs[0].Magic;
	refCount	=	Reflex[0].ChunkCount;
	printf("3rd reflexive points to 0x%x\n with a count of %d\n",refOffset,refCount);
	if(refOffset==(-1) || refCount<0){
    	refCount	=	0;
    }
	for(i=0;i<refCount;i++){
		RawOffset =  Imports[j].offset;
		fseek(Map.Stream,Imports[j].offset,0);
		fwrite(Imports[j].data,1,Imports[j].size,Map.Stream);
		fseek(Map.Stream,refOffset+(i*44),0);
		fwrite(&RawOffset,1,sizeof(uint32),Map.Stream);
		j++;
	}
	//MODE 4
	fseek(Map.Stream,Map.BSPs[0].Offset+8,0);
	fread(&refOffset,1,4,Map.Stream);
	refOffset	-=	Map.BSPs[0].Magic;	
	printf("0x%x\n",refOffset-Map.BSPs[0].Offset);
	if (refOffset+Map.BSPs[0].Magic != 0 ) {
                                    
         fseek(Map.Stream,refOffset+128,0);
	     fread(Reflex2,1,sizeof(Reflexive),Map.Stream);
	     refOffset	=	Reflex2[0].Offset-Map.BSPs[0].Magic;
	     refCount	=	Reflex2[0].ChunkCount;
	
    	 fseek(Map.Stream,refOffset+64,0);
	     fread(Reflex,1,sizeof(Reflexive),Map.Stream);
	     refOffset	=	Reflex[0].Offset-Map.BSPs[0].Magic;
	     refCount	=	Reflex[0].ChunkCount;
	}else{     
		refCount	=	0;
	}
	printf("4th reflexive points to 0x%x\n with a count of %d\n",refOffset,refCount);
///	refCount	=	0;
	for(i=0;i<refCount;i++){
		RawOffset =  Imports[j].offset;
		fseek(Map.Stream,Imports[j].offset,0);
		fwrite(Imports[j].data,1,Imports[j].size,Map.Stream);
		fseek(Map.Stream,refOffset+(i*56)+12,0);
		fwrite(&RawOffset,1,sizeof(uint32),Map.Stream);
		j++;
	}
    CloseMap(Map);
  //  CloseMap(Source);
 //   system("pause");
}
