/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Mon Jan  2 21:16:21 2006
 */
 
/*Revisions:
Wed Feb  1 14:28:38 2006
Added BSP & Light Map Support, now bsp reflexives should be invisible.
*/
#include "halo2.h"


//The following Procedures take a tag and offset to reflexive, arguments
int GetReflexiveAddressTag(MAP_STRUCT Map,int tag,uint32 offset){
	Reflexive Reflex[1];
	int BSP;
	BSP==isBSP(tag,Map);
	if((BSP=isBSP(tag,Map))!=(-1)){
		fseek(Map.Stream,
		Map.BSPs[BSP].Offset+offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].Offset-Map.BSPs[BSP].Magic;
	}else if((BSP=isLTMP(tag,Map))!=(-1)){
		fseek(Map.Stream,
		Map.LTMPs[BSP].Offset+offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].Offset-Map.LTMPs[BSP].Magic;
	}else{
		fseek(Map.Stream,
		(Map.ItemIndex[tag].offset-Map.SecondaryMagic)+offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].Offset-Map.SecondaryMagic;
	}
	return -1;
}

int GetReflexiveChunkCountTag(MAP_STRUCT Map,int tag,uint32 offset){
	Reflexive Reflex[1];
	int BSP;
	if((BSP=isBSP(tag,Map))!=(-1)){
		fseek(Map.Stream,
		Map.BSPs[BSP].Offset+offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].ChunkCount;
	}else if((BSP=isLTMP(tag,Map))!=(-1)){
		fseek(Map.Stream,
		Map.LTMPs[BSP].Offset+offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].ChunkCount;
	}else{
		fseek(Map.Stream,
		(Map.ItemIndex[tag].offset-Map.SecondaryMagic)+offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].ChunkCount;
	}
}
//The following Procedures raw offset to reflexive, arguments
int GetReflexiveAddress(MAP_STRUCT Map,uint32 offset){
	Reflexive Reflex[1];
	int BSP;
	if((BSP=isWithinBSP(offset,Map))!=(-1)){
		fseek(Map.Stream,
		offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		printf(".");
		return Reflex[0].Offset-Map.BSPs[BSP].Magic;
	}else if((BSP=isWithinLTMP(offset,Map))!=(-1)){
		fseek(Map.Stream,
		offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].Offset-Map.LTMPs[BSP].Magic;
	}else{
		fseek(Map.Stream,
		offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].Offset-Map.SecondaryMagic;
	}
}

int GetReflexiveChunkCount(MAP_STRUCT Map,uint32 offset){
	Reflexive Reflex[1];
	int BSP;
	if((BSP=isWithinBSP(offset,Map))!=(-1)){
		fseek(Map.Stream,
		offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].ChunkCount;
	}else if((BSP=isWithinLTMP(offset,Map))!=(-1)){
		fseek(Map.Stream,
		offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].ChunkCount;
	}else{
		fseek(Map.Stream,
		offset,0);
		fread(Reflex,1,sizeof(Reflexive),Map.Stream);
		return Reflex[0].ChunkCount;
	}
}
///////////////////////////
void FixReflexive(int tag, uint32 offset, int pointer_tag, uint32 pointer_offset, MAP_STRUCT Map){
	Reflexive Reflex[1];
	fseek(Map.Stream,offset,0);
	fread(Reflex,1,sizeof(Reflexive),Map.Stream);
	fseek(Map.Stream,offset,0);
	Reflex[0].Offset=Map.ItemIndex[pointer_tag].offset+pointer_offset;
	fwrite(Reflex,1,sizeof(Reflexive),Map.Stream);
}
