/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Wed Jan  4 22:59:44 2006
 */
#include "halo2.h"


DEP_RET *DependencyScan(int tag, MAP_STRUCT Map, int *count){
	uint32 *MetaBuff,*Class;
	uint32 i,j=0;
	DEP_RET *ret;
	
	MetaBuff	=	calloc((Map.ItemIndex[tag].size/4)+1,4);
	ret			=	calloc(1,sizeof(DEP_RET));
	
	fseek(Map.Stream,Map.ItemIndex[tag].offset-Map.SecondaryMagic,0);
	fread(MetaBuff,Map.ItemIndex[tag].size,1,Map.Stream);
	
	for(i=0;i<Map.ItemIndex[tag].size;i++){
		Class=ClassEdianSwap(MetaBuff+i);
		if(	isClass(Class,Map)==0 &&
			(MetaBuff[i+1] & 0xFFFF) == (MetaBuff[i+1] >> 16)- 0xE174 &&
			(MetaBuff[i+1] & 0xFFFF) < Map.MetaCount){
				realloc(ret,sizeof(DEP_RET));
				ret[j].Offset	=	i;
				ret[j].ID		=	MetaBuff[i];
				j++;
				HaloFree(Class);
				continue;
			}
		HaloFree(Class);
	}
	count[0]	=	j;
	return			ret;
}

LID_RET *LoneIDScan(int tag, MAP_STRUCT Map, int *count){
	uint32 *MetaBuff,i,j=0;
	LID_RET *ret;
	
	MetaBuff	=	calloc((Map.ItemIndex[tag].size/4)+1,4);
	ret			=	calloc(1,sizeof(LID_RET));
	
	fseek(Map.Stream,Map.ItemIndex[tag].offset-Map.SecondaryMagic,0);
	fread(MetaBuff,Map.ItemIndex[tag].size,1,Map.Stream);
	
	for(i=0;i<Map.ItemIndex[tag].size/4;i++){
		if(	(MetaBuff[i] & 0xFFFF) == (MetaBuff[i] >> 16)-0xE174 &&
			(MetaBuff[i] & 0xFFFF) < Map.MetaCount){
				realloc(ret,sizeof(LID_RET));
				ret[j].Offset	=	i;
				ret[j].ID		=	(uint32 *)MetaBuff[i];
				j++;
				continue;
			}
	}
	count[0]	=	j;
	return			ret;
}


STR_ID *StringIDScan(int tag, MAP_STRUCT Map,int *count){
	StringIndice *MetaBuff;
	uint32 i,j=0;
	STR_ID *ret;
	
	MetaBuff	=	calloc((Map.ItemIndex[tag].size/4)+1,4);
	ret			=	calloc(1,sizeof(STR_ID));
	
	fseek(Map.Stream,Map.ItemIndex[tag].offset-Map.SecondaryMagic,0);
	fread(MetaBuff,Map.ItemIndex[tag].size,1,Map.Stream);
	
	for(i=0;i<Map.ItemIndex[tag].size/sizeof(StringIndice);i++){
		if( MetaBuff[i].StringLen == strlen( FindStringID(MetaBuff[i].StringRef,Map) )){
				realloc(ret,			sizeof(STR_ID));
				ret[j].Offset		=	i*sizeof(StringIndice);
				ret[j].Refrence		=	MetaBuff[i].StringRef;
				ret[j].Count		=	MetaBuff[i].StringLen;
				j++;
				continue;
		}

	}
	free(MetaBuff);
	count[0]	=	j;
	return			ret;
}

REFLEX_RET *ReflexiveScan(int tag, MAP_STRUCT Map,int *count){
	uint32 *MetaBuff,i,j=0;
	REFLEX_RET *ret;
	
	MetaBuff	=	calloc((Map.ItemIndex[tag].size/4)+1,4);
	ret			=	calloc(1,sizeof(REFLEX_RET));
	
	fseek(Map.Stream,Map.ItemIndex[tag].offset-Map.SecondaryMagic,0);
	fread(MetaBuff,Map.ItemIndex[tag].size,1,Map.Stream);
	
	for(i=0;i<Map.ItemIndex[tag].size/4;i++){
		if(MetaBuff[i]>Map.SecondaryMagic){
			if(MetaBuff[i]>Map.ItemIndex[0].offset && 
				Map.ItemIndex[0].offset+Map.Header->metaSize){
#ifdef	CHUNKS_MATTER
				if(MetaBuff[i-1]>0 && MetaBuff[i-1]<MAX_CHUNKS){
					realloc(ret,sizeof(REFLEX_RET));
					ret[j].Offset		=	i*4;
					ret[j].Refrence		=	MetaBuff[i];
					ret[j].Count		=	MetaBuff[i-1];
					j++;
					continue;
				}
#else
				realloc(ret,sizeof(REFLEX_RET));
				ret[j].Offset		=	i*4;
				ret[j].Refrence		=	MetaBuff[i];
				ret[j].Count		=	MetaBuff[i-1];
				j++;
				continue;	
#endif
			}
		}
	}
	free(MetaBuff);
	count[0]	=	j;
	return			ret;
}
