/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Wed Jan  4 23:51:59 2006
 */
#include "halo2.h"
 
void ShiftUnicodeStringTables(MAP_STRUCT Map, int offset){
     uint32 	*Matg,i;
     Matg=		(uint32 *)malloc(Map.ItemIndex[0].size);
     
     fseek(Map.Stream,
     	Map.ItemIndex[0].offset-Map.SecondaryMagic,0);
     
     fread(Matg, Map.ItemIndex[0].size,
     	1,Map.Stream);
     
     for(i=0;i<9;i++){
		 Matg[100+(i*16)+8]+=offset;
		 Matg[100+(i*16)+12]+=offset;
	 }
     fseek(Map.Stream,
     	Map.ItemIndex[0].offset-Map.SecondaryMagic,0);
     
     fwrite(Matg, Map.ItemIndex[0].size,
     	1,Map.Stream);
}

void ShiftSBSPBlock(MAP_STRUCT Map, int bsp,int offset){
	uint32 rOffset;
	if(bsp<0 || bsp>Map.bspCount)
		return;		
	fseek(Map.Stream,Map.BSPs[bsp].OffsetToOffset,0);
	fread(&rOffset,1,sizeof(uint32),Map.Stream);
	rOffset+=offset;
	fwrite(&rOffset,1,sizeof(uint32),Map.Stream);
}

void ShiftScriptTable(MAP_STRUCT Map, int offset){
	Map.Header->offsetToScriptReferenceStrings+=offset;
	fseek(Map.Stream,0,0);
	fwrite(Map.Header,1,2048,Map.Stream);
}
void ShiftScriptIndex(MAP_STRUCT Map, int offset){
	Map.Header->offsetToScriptReferenceIndex+=offset;
	fseek(Map.Stream,0,0);
	fwrite(Map.Header,1,2048,Map.Stream);
}
void ShiftFileTable(MAP_STRUCT Map, int offset){
	Map.Header->fileTableOffset+=offset;
	fseek(Map.Stream,0,0);
	fwrite(Map.Header,1,2048,Map.Stream);
}
void ShiftFileIndex(MAP_STRUCT Map, int offset){
	Map.Header->filesIndex+=offset;
	fseek(Map.Stream,0,0);
	fwrite(Map.Header,1,2048,Map.Stream);
}
void ShiftIndex(MAP_STRUCT Map, int offset){
	Map.Header->indexOffset+=offset;
	fseek(Map.Stream,0,0);
	fwrite(Map.Header,1,2048,Map.Stream);
}
void ShiftStringTable128(MAP_STRUCT Map, int offset){
	Map.Header->offsetToScriptReference128+=offset;
	fseek(Map.Stream,0,0);
	fwrite(Map.Header,1,2048,Map.Stream);
}
