/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Wed Jan  4 23:51:59 2006
 */
#include "halo2.h"

#define	ADPCM_MONO	0x01
#define	ADPCM_STERO	0x02
#define	WMA			0x03

#define GetTagSize(x,y)		y.ItemIndex[x].size
#define GetTagOffset(x,y)	y.ItemIndex[x].offset-y.SecondaryMagic

typedef struct{
	dword unknown[2];
    short index;
    short chunkCount;
}SND_OPTS;

typedef struct{
    dword unknown[3];
    short index;
    short chunkCount;
}SND_PIECE;

typedef struct{
    uint32 rawOffset;
    uint32 size;
    uint32 eff;
}SND_RAW;

char *GetSoundRaw(int tag, MAP_STRUCT Map, int option, char *type,int *rsize){
	uint8		format, chunkCount;
	short		index;
	int			Coconuts,size,i,j,k;
	Reflexive	SoundOptions[1],SoundPieces[1],SoundRaw[1];
	SND_OPTS	*SoundOption;
	SND_PIECE	*SoundPiece;
	SND_RAW		*SoundData;
	
	fseek(Map.Stream,
	GetTagOffset(tag,Map)+4,0);
	fread(&format,1,1,Map.Stream);
	
	fseek(Map.Stream,
	GetTagOffset(tag,Map)+8,0);
	fread(&index,1,1,Map.Stream);
	
	fseek(Map.Stream,
	GetTagOffset(tag,Map)+10,0);
	fread(&chunkCount,1,1,Map.Stream);
	
	Coconuts=FindCoconuts(Map);
	fseek(Map.Stream,
	GetTagOffset(Coconuts,Map)+32,0);
	fread(SoundOptions,sizeof(Reflexive),1,Map.Stream);
	
	fseek(Map.Stream,
	GetTagOffset(Coconuts,Map)+40,0);
	fread(SoundPieces,sizeof(Reflexive),1,Map.Stream);
	
	fseek(Map.Stream,
	GetTagOffset(Coconuts,Map)+64,0);
	fread(SoundRaw,sizeof(Reflexive),1,Map.Stream);
	
	SoundOptions[0].Offset	-=	Map.SecondaryMagic;
	SoundPieces[0].Offset	-=	Map.SecondaryMagic;
	SoundRaw[0].Offset		-=	Map.SecondaryMagic;
	SoundOption				=	calloc(SoundOptions[0].ChunkCount,sizeof(SND_OPTS));
	SoundPiece				=	calloc(SoundPieces[0].ChunkCount,sizeof(SND_PIECE));
	SoundData				=	calloc(SoundRaw[0].ChunkCount,sizeof(SND_RAW));
	
	fseek(Map.Stream,
	SoundOptions[0].Offset,0);
	fread(SoundOption,
	SoundOptions[0].ChunkCount,sizeof(SND_OPTS),
	Map.Stream);
	
	fseek(Map.Stream,
	SoundPieces[0].Offset,0);
	fread(SoundPiece,
	SoundPieces[0].ChunkCount,sizeof(SND_PIECE),
	Map.Stream);

	fseek(Map.Stream,
	SoundRaw[0].Offset,0);
	fread(SoundData,
	SoundRaw[0].ChunkCount,sizeof(SND_RAW),
	Map.Stream);
	//OK AT THE POINT WHERE I"VE LOADED THE SOUNDS INFO
	//
	//for(i=0;i<SoundOption[option].chunkCount;i++){
	//	for(j=0;
}
