/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Written by: Joshua Horacsek
 *  Mon Jan  2 22:28:12 2006
 */
 
#include "halo2.h"

char *ClassEdianSwap(char *class) {
	char *ret;
	ret=malloc(5);
	ret[0]=class[3];
	ret[1]=class[2];
	ret[2]=class[1];
	ret[3]=class[0];
	ret[4]^=ret[4];
	return ret;
}
int isClass(char *class,MAP_STRUCT Map) {
	int i;
	char *Class;
	Class=ClassEdianSwap(class);
	for(i=0;i<Map.Index->tagcount;i++){
		if(strncmp(Class,Map.TagIndex[i].objectClass,4)==0){
			HaloFree(Class);
			return 0;
		}
	}
	HaloFree(Class);
	return -1;
}

int isBSP(int tag, MAP_STRUCT Map){
	int i;
	for(i=0;i<Map.bspCount;i++){
		if(Map.BSPs[i].Tag==tag)
			return i;
	}
	return (-1);
}

int isWithinBSP(int addy, MAP_STRUCT Map){
	int i;
	for(i=0;i<Map.bspCount;i++){
		if(	addy >= Map.BSPs[i].Offset &&
			addy <= Map.BSPs[i].Offset + Map.BSPs[i].Size)
			return i;
	}
	return (-1);
}

int isLTMP(int tag, MAP_STRUCT Map){
	int i;
	for(i=0;i<Map.ltmpCount;i++){
		if(Map.LTMPs[i].Tag==tag)
			return i;
	}
	return (-1);
}

int isWithinLTMP(int addy, MAP_STRUCT Map){
	int i;
	for(i=0;i<Map.ltmpCount;i++){
		if(	addy >= Map.LTMPs[i].Offset &&
			addy <= Map.LTMPs[i].Offset + Map.LTMPs[i].Size)
			return i;
	}
	return (-1);
}

uint32 XORSum(uint32 *buffer,int len){
	uint32 sum=0,i;
	for(i=0;i<len;i++){
		sum^=buffer[i];
	}
	return sum;
}

uint32 XORSign(MAP_STRUCT Map){
	uint32 len,sig;
	uint8 *buff;
	fseek(Map.Stream,0,SEEK_END);
	len=ftell(Map.Stream);
	fseek(Map.Stream,2048,0);
	buff=malloc(len-2048);
	fread(buff,len-2048,1,Map.Stream);
	sig=XORSum((uint32 *)buff,(len-2048)/4);
	free(buff);
	fseek(Map.Stream,720,0);
	fwrite(&sig,sizeof(uint32),1,Map.Stream);
	return sig;
}

int FindCoconuts(MAP_STRUCT Map){
#ifdef FIND_COCONUTS
	int i;
	char *Class=ClassEdianSwap("ugh!");
	for(i=0;i<Map.MetaCount;i++){
		if(strncmp(Class,Map.ItemIndex[i].tagclass,4)==0){
			HaloFree(Class);
			return i;
		}
	}
	HaloFree(Class);
	return -1;
#else
	return Map.MetaCount-1;
#endif
}

void FixMetaHeader(MAP_STRUCT Map, int size){
	Map.Header->metaSize	+=	size;
	Map.Header->NonRawSize	+=	size;
	fseek(	Map.Stream,0,0);
	fwrite(	Map.Header,1,2048,Map.Stream);
}

void FixPadding(MAP_STRUCT Map){
}
